Skip to content
Start here

Enable or Disable Total TLS

client.ACM.TotalTLS.Update(ctx, params) (*TotalTLSUpdateResponse, error)
POST/zones/{zone_id}/acm/total_tls

Set Total TLS Settings or disable the feature for a Zone.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
SSL and Certificates Write
ParametersExpand Collapse
params TotalTLSUpdateParams
ZoneID param.Field[string]

Path param: Identifier.

maxLength32
Enabled param.Field[bool]

Body param: If enabled, Total TLS will order a hostname specific TLS certificate for any proxied A, AAAA, or CNAME record in your zone.

CertificateAuthority param.Field[CertificateAuthority]optional

Body param: The Certificate Authority that Total TLS certificates will be issued through.

ReturnsExpand Collapse
type TotalTLSUpdateResponse struct{…}
CertificateAuthority CertificateAuthorityoptional

The Certificate Authority that Total TLS certificates will be issued through.

One of the following:
const CertificateAuthorityGoogle CertificateAuthority = "google"
const CertificateAuthorityLetsEncrypt CertificateAuthority = "lets_encrypt"
const CertificateAuthoritySSLCom CertificateAuthority = "ssl_com"
Enabled booloptional

If enabled, Total TLS will order a hostname specific TLS certificate for any proxied A, AAAA, or CNAME record in your zone.

ValidityPeriod TotalTLSUpdateResponseValidityPeriodoptional

The validity period in days for the certificates ordered via Total TLS.

Enable or Disable Total TLS

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/acm"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  totalTLS, err := client.ACM.TotalTLS.Update(context.TODO(), acm.TotalTLSUpdateParams{
    ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    Enabled: cloudflare.F(true),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", totalTLS.ValidityPeriod)
}
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "certificate_authority": "google",
    "enabled": true,
    "validity_period": 90
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "certificate_authority": "google",
    "enabled": true,
    "validity_period": 90
  }
}